Overview | Package | Class | Tree | Deprecated | Index | Help
| Spring Framework
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.springframework.jmx.export.assembler
Class AbstractReflectiveMBeanInfoAssembler

    java.lang.Object
      org.springframework.jmx.export.assembler.AbstractMBeanInfoAssembler
          org.springframework.jmx.export.assembler.AbstractReflectiveMBeanInfoAssembler

All Implemented Interfaces:
  MBeanInfoAssembler

Direct Known Subclasses:
  AbstractConfigurableMBeanInfoAssembler, MetadataMBeanInfoAssembler

    public abstract class AbstractReflectiveMBeanInfoAssembler

extends AbstractMBeanInfoAssembler

Builds on the `AbstractMBeanInfoAssembler` superclass to add a basic algorithm for building metadata based on the reflective metadata of the MBean class.

The logic for creating MBean metadata from the reflective metadata is contained in this class, but this class makes no decisions as to which methods and properties are to be exposed. Instead it gives subclasses a chance to 'vote' on each property or method through the `includeXXX` methods.

Subclasses are also given the opportunity to populate attribute and operation metadata with additional descriptors once the metadata is assembled through the `populateXXXDescriptor` methods.

Since:
  1.2
Author:
  Rob Harrop, Juergen Hoeller
See Also:
  `includeOperation(java.lang.reflect.Method, java.lang.String)`, `includeReadAttribute(java.lang.reflect.Method, java.lang.String)`, `includeWriteAttribute(java.lang.reflect.Method, java.lang.String)`, `populateAttributeDescriptor(javax.management.Descriptor, java.lang.reflect.Method, java.lang.reflect.Method, java.lang.String)`, `populateOperationDescriptor(javax.management.Descriptor, java.lang.reflect.Method, java.lang.String)`

Field Summary
`protected static int` | `ATTRIBUTE_OPERATION_VISIBILITY` Lowest visibility, used for operations that correspond to accessors or mutators for attributes.
`protected static java.lang.String` | `FIELD_CLASS` Constant identifier for the class field in a JMX `Descriptor`.
`protected static java.lang.String` | `FIELD_CURRENCY_TIME_LIMIT` Constant identifier for the currency time limit field in a JMX `Descriptor`.
`protected static java.lang.String` | `FIELD_DEFAULT` Constant identifier for the default field in a JMX `Descriptor`.
`protected static java.lang.String` | `FIELD_DISPLAY_NAME` Constant identifier for the displayName field in a JMX `Descriptor`.
`protected static java.lang.String` | `FIELD_GET_METHOD` Identifies a getter method in a JMX `Descriptor`.
`protected static java.lang.String` | `FIELD_LOG` Constant identifier for the log field in a JMX `Descriptor`.
`protected static java.lang.String` | `FIELD_LOG_FILE` Constant identifier for the logfile field in a JMX `Descriptor`.
`protected static java.lang.String` | `FIELD_METRIC_CATEGORY` Constant identifier for the custom metricCategory field in a JMX `Descriptor`.
`protected static java.lang.String` | `FIELD_METRIC_TYPE` Constant identifier for the metricType field in a JMX `Descriptor`.
`protected static java.lang.String` | `FIELD_PERSIST_LOCATION` Constant identifier for the persistLocation field in a JMX `Descriptor`.
`protected static java.lang.String` | `FIELD_PERSIST_NAME` Constant identifier for the persistName field in a JMX `Descriptor`.
`protected static java.lang.String` | `FIELD_PERSIST_PERIOD` Constant identifier for the persistPeriod field in a JMX `Descriptor`.
`protected static java.lang.String` | `FIELD_PERSIST_POLICY` Constant identifier for the persistPolicy field in a JMX `Descriptor`.
`protected static java.lang.String` | `FIELD_ROLE` Constant identifier for the role field in a JMX `Descriptor`.
`protected static java.lang.String` | `FIELD_SET_METHOD` Identifies a setter method in a JMX `Descriptor`.
`protected static java.lang.String` | `FIELD_UNITS` Constant identifier for the units field in a JMX `Descriptor`.
`protected static java.lang.String` | `FIELD_VISIBILITY` Constant identifier for the visibility field in a JMX `Descriptor`.
`protected static java.lang.String` | `ROLE_GETTER` Constant identifier for the getter role field value in a JMX `Descriptor`.
`protected static java.lang.String` | `ROLE_OPERATION` Identifies an operation (method) in a JMX `Descriptor`.
`protected static java.lang.String` | `ROLE_SETTER` Constant identifier for the setter role field value in a JMX `Descriptor`.

Constructor Summary
`AbstractReflectiveMBeanInfoAssembler()`

Method Summary
`protected void` | `applyCurrencyTimeLimit(javax.management.Descriptor desc, int currencyTimeLimit)` Apply the given JMX "currencyTimeLimit" value to the given descriptor.
`protected void` | `applyDefaultCurrencyTimeLimit(javax.management.Descriptor desc)` Set the `currencyTimeLimit` field to the specified "defaultCurrencyTimeLimit", if any (by default none).
`protected javax.management.modelmbean.ModelMBeanOperationInfo` | `createModelMBeanOperationInfo(java.lang.reflect.Method method, java.lang.String name, java.lang.String beanKey)` Creates an instance of `ModelMBeanOperationInfo` for the given method.
`protected java.lang.String` | `getAttributeDescription(java.beans.PropertyDescriptor propertyDescriptor, java.lang.String beanKey)` Get the description for a particular attribute.
`protected javax.management.modelmbean.ModelMBeanAttributeInfo[]` | `getAttributeInfo(java.lang.Object managedBean, java.lang.String beanKey)` Iterate through all properties on the MBean class and gives subclasses the chance to vote on the inclusion of both the accessor and mutator.
`protected java.lang.Class` | `getClassForDescriptor(java.lang.Object managedBean)` Return the class to be used for the JMX descriptor field "class".
`protected java.lang.Integer` | `getDefaultCurrencyTimeLimit()` Return default value for the JMX field "currencyTimeLimit", if any.
`protected java.lang.String` | `getOperationDescription(java.lang.reflect.Method method, java.lang.String beanKey)` Get the description for a particular operation.
`protected javax.management.modelmbean.ModelMBeanOperationInfo[]` | `getOperationInfo(java.lang.Object managedBean, java.lang.String beanKey)` Iterate through all methods on the MBean class and gives subclasses the chance to vote on their inclusion.
`protected javax.management.MBeanParameterInfo[]` | `getOperationParameters(java.lang.reflect.Method method, java.lang.String beanKey)` Create parameter info for the given method.
`protected abstract boolean` | `includeOperation(java.lang.reflect.Method method, java.lang.String beanKey)` Allows subclasses to vote on the inclusion of a particular operation.
`protected abstract boolean` | `includeReadAttribute(java.lang.reflect.Method method, java.lang.String beanKey)` Allows subclasses to vote on the inclusion of a particular attribute accessor.
`protected abstract boolean` | `includeWriteAttribute(java.lang.reflect.Method method, java.lang.String beanKey)` Allows subclasses to vote on the inclusion of a particular attribute mutator.
`protected boolean` | `isExposeClassDescriptor()` Return whether to expose the JMX descriptor field "class" for managed operations.
`protected boolean` | `isUseStrictCasing()` Return whether strict casing for attributes is enabled.
`protected void` | `populateAttributeDescriptor(javax.management.Descriptor desc, java.lang.reflect.Method getter, java.lang.reflect.Method setter, java.lang.String beanKey)` Allows subclasses to add extra fields to the `Descriptor` for a particular attribute.
`protected void` | `populateMBeanDescriptor(javax.management.Descriptor descriptor, java.lang.Object managedBean, java.lang.String beanKey)` Allows subclasses to add extra fields to the `Descriptor` for an MBean.
`protected void` | `populateOperationDescriptor(javax.management.Descriptor desc, java.lang.reflect.Method method, java.lang.String beanKey)` Allows subclasses to add extra fields to the `Descriptor` for a particular operation.
`void` | `setDefaultCurrencyTimeLimit(java.lang.Integer defaultCurrencyTimeLimit)` Set the default for the JMX field "currencyTimeLimit".
`void` | `setExposeClassDescriptor(boolean exposeClassDescriptor)` Set whether to expose the JMX descriptor field "class" for managed operations.
`void` | `setUseStrictCasing(boolean useStrictCasing)` Set whether to use strict casing for attributes.

Methods inherited from class org.springframework.jmx.export.assembler.AbstractMBeanInfoAssembler
`checkManagedBean, getClassName, getClassToExpose, getClassToExpose, getConstructorInfo, getDescription, getMBeanInfo, getNotificationInfo, getTargetClass`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### FIELD_GET_METHOD

    protected static final java.lang.String FIELD_GET_METHOD

  Identifies a getter method in a JMX `Descriptor`.

  See Also:
    Constant Field Values

### FIELD_SET_METHOD

    protected static final java.lang.String FIELD_SET_METHOD

  Identifies a setter method in a JMX `Descriptor`.

  See Also:
    Constant Field Values

### FIELD_ROLE

    protected static final java.lang.String FIELD_ROLE

  Constant identifier for the role field in a JMX `Descriptor`.

  See Also:
    Constant Field Values

### ROLE_GETTER

    protected static final java.lang.String ROLE_GETTER

  Constant identifier for the getter role field value in a JMX `Descriptor`.

  See Also:
    Constant Field Values

### ROLE_SETTER

    protected static final java.lang.String ROLE_SETTER

  Constant identifier for the setter role field value in a JMX `Descriptor`.

  See Also:
    Constant Field Values

### ROLE_OPERATION

    protected static final java.lang.String ROLE_OPERATION

  Identifies an operation (method) in a JMX `Descriptor`.

  See Also:
    Constant Field Values

### FIELD_VISIBILITY

    protected static final java.lang.String FIELD_VISIBILITY

  Constant identifier for the visibility field in a JMX `Descriptor`.

  See Also:
    Constant Field Values

### ATTRIBUTE_OPERATION_VISIBILITY

    protected static final int ATTRIBUTE_OPERATION_VISIBILITY

  Lowest visibility, used for operations that correspond to accessors or mutators for attributes.

  See Also:
    `FIELD_VISIBILITY`, Constant Field Values

### FIELD_CLASS

    protected static final java.lang.String FIELD_CLASS

  Constant identifier for the class field in a JMX `Descriptor`.

  See Also:
    Constant Field Values

### FIELD_LOG

    protected static final java.lang.String FIELD_LOG

  Constant identifier for the log field in a JMX `Descriptor`.

  See Also:
    Constant Field Values

### FIELD_LOG_FILE

    protected static final java.lang.String FIELD_LOG_FILE

  Constant identifier for the logfile field in a JMX `Descriptor`.

  See Also:
    Constant Field Values

### FIELD_CURRENCY_TIME_LIMIT

    protected static final java.lang.String FIELD_CURRENCY_TIME_LIMIT

  Constant identifier for the currency time limit field in a JMX `Descriptor`.

  See Also:
    Constant Field Values

### FIELD_DEFAULT

    protected static final java.lang.String FIELD_DEFAULT

  Constant identifier for the default field in a JMX `Descriptor`.

  See Also:
    Constant Field Values

### FIELD_PERSIST_POLICY

    protected static final java.lang.String FIELD_PERSIST_POLICY

  Constant identifier for the persistPolicy field in a JMX `Descriptor`.

  See Also:
    Constant Field Values

### FIELD_PERSIST_PERIOD

    protected static final java.lang.String FIELD_PERSIST_PERIOD

  Constant identifier for the persistPeriod field in a JMX `Descriptor`.

  See Also:
    Constant Field Values

### FIELD_PERSIST_LOCATION

    protected static final java.lang.String FIELD_PERSIST_LOCATION

  Constant identifier for the persistLocation field in a JMX `Descriptor`.

  See Also:
    Constant Field Values

### FIELD_PERSIST_NAME

    protected static final java.lang.String FIELD_PERSIST_NAME

  Constant identifier for the persistName field in a JMX `Descriptor`.

  See Also:
    Constant Field Values

### FIELD_DISPLAY_NAME

    protected static final java.lang.String FIELD_DISPLAY_NAME

  Constant identifier for the displayName field in a JMX `Descriptor`.

  See Also:
    Constant Field Values

### FIELD_UNITS

    protected static final java.lang.String FIELD_UNITS

  Constant identifier for the units field in a JMX `Descriptor`.

  See Also:
    Constant Field Values

### FIELD_METRIC_TYPE

    protected static final java.lang.String FIELD_METRIC_TYPE

  Constant identifier for the metricType field in a JMX `Descriptor`.

  See Also:
    Constant Field Values

### FIELD_METRIC_CATEGORY

    protected static final java.lang.String FIELD_METRIC_CATEGORY

  Constant identifier for the custom metricCategory field in a JMX `Descriptor`.

  See Also:
    Constant Field Values

Constructor Detail

### AbstractReflectiveMBeanInfoAssembler

    public AbstractReflectiveMBeanInfoAssembler()

Method Detail

### setDefaultCurrencyTimeLimit

    public void setDefaultCurrencyTimeLimit(java.lang.Integer defaultCurrencyTimeLimit)

  Set the default for the JMX field "currencyTimeLimit". The default will usually indicate to never cache attribute values.

  Default is none, not explicitly setting that field, as recommended by the JMX 1.2 specification. This should result in "never cache" behavior, always reading attribute values freshly (which corresponds to a "currencyTimeLimit" of `-1` in JMX 1.2).

  However, some JMX implementations (that do not follow the JMX 1.2 spec in that respect) might require an explicit value to be set here to get "never cache" behavior: for example, JBoss 3.2.x.

  Note that the "currencyTimeLimit" value can also be specified on a managed attribute or operation. The default value will apply if not overridden with a "currencyTimeLimit" value `>= 0` there: a metadata "currencyTimeLimit" value of `-1` indicates to use the default; a value of `0` indicates to "always cache" and will be translated to `Integer.MAX_VALUE`; a positive value indicates the number of cache seconds.

  See Also:
    `AbstractJmxAttribute.setCurrencyTimeLimit(int)`, `applyCurrencyTimeLimit(javax.management.Descriptor, int)`

### getDefaultCurrencyTimeLimit

    protected java.lang.Integer getDefaultCurrencyTimeLimit()

  Return default value for the JMX field "currencyTimeLimit", if any.

### setUseStrictCasing

    public void setUseStrictCasing(boolean useStrictCasing)

  Set whether to use strict casing for attributes. Enabled by default.

  When using strict casing, a JavaBean property with a getter such as `getFoo()` translates to an attribute called `Foo`. With strict casing disabled, `getFoo()` would translate to just `foo`.

### isUseStrictCasing

    protected boolean isUseStrictCasing()

  Return whether strict casing for attributes is enabled.

### setExposeClassDescriptor

    public void setExposeClassDescriptor(boolean exposeClassDescriptor)

  Set whether to expose the JMX descriptor field "class" for managed operations. Default is "false", letting the JMX implementation determine the actual class through reflection.

  Set this property to `true` for JMX implementations that require the "class" field to be specified, for example WebLogic's. In that case, Spring will expose the target class name there, in case of a plain bean instance or a CGLIB proxy. When encountering a JDK dynamic proxy, the first interface implemented by the proxy will be specified.

  WARNING: Review your proxy definitions when exposing a JDK dynamic proxy through JMX, in particular with this property turned to `true`: the specified interface list should start with your management interface in this case, with all other interfaces following. In general, consider exposing your target bean directly or a CGLIB proxy for it instead.

  See Also:
    `getClassForDescriptor(Object)`

### isExposeClassDescriptor

    protected boolean isExposeClassDescriptor()

  Return whether to expose the JMX descriptor field "class" for managed operations.

### getAttributeInfo

    protected javax.management.modelmbean.ModelMBeanAttributeInfo[] getAttributeInfo(java.lang.Object managedBean,
                                                                                     java.lang.String beanKey)
                                                                              throws javax.management.JMException

  Iterate through all properties on the MBean class and gives subclasses the chance to vote on the inclusion of both the accessor and mutator. If a particular accessor or mutator is voted for inclusion, the appropriate metadata is assembled and passed to the subclass for descriptor population.

  Specified by:
    `getAttributeInfo` in class `AbstractMBeanInfoAssembler`
  Parameters:
    `managedBean` - the bean instance (might be an AOP proxy)
    `beanKey` - the key associated with the MBean in the beans map of the `MBeanExporter`
  Returns:
    the attribute metadata
  Throws:
    `javax.management.JMException` - in case of errors
  See Also:
    `populateAttributeDescriptor(javax.management.Descriptor, java.lang.reflect.Method, java.lang.reflect.Method, java.lang.String)`

### getOperationInfo

    protected javax.management.modelmbean.ModelMBeanOperationInfo[] getOperationInfo(java.lang.Object managedBean,
                                                                                     java.lang.String beanKey)

  Iterate through all methods on the MBean class and gives subclasses the chance to vote on their inclusion. If a particular method corresponds to the accessor or mutator of an attribute that is inclued in the managment interface, then the corresponding operation is exposed with the "role" descriptor field set to the appropriate value.

  Specified by:
    `getOperationInfo` in class `AbstractMBeanInfoAssembler`
  Parameters:
    `managedBean` - the bean instance (might be an AOP proxy)
    `beanKey` - the key associated with the MBean in the beans map of the `MBeanExporter`
  Returns:
    the operation metadata
  See Also:
    `populateOperationDescriptor(javax.management.Descriptor, java.lang.reflect.Method, java.lang.String)`

### createModelMBeanOperationInfo

    protected javax.management.modelmbean.ModelMBeanOperationInfo createModelMBeanOperationInfo(java.lang.reflect.Method method,
                                                                                                java.lang.String name,
                                                                                                java.lang.String beanKey)

  Creates an instance of `ModelMBeanOperationInfo` for the given method. Populates the parameter info for the operation.

  Parameters:
    `method` - the `Method` to create a `ModelMBeanOperationInfo` for
    `name` - the name for the operation info
    `beanKey` - the key associated with the MBean in the beans map of the `MBeanExporter`
  Returns:
    the `ModelMBeanOperationInfo`

### getClassForDescriptor

    protected java.lang.Class getClassForDescriptor(java.lang.Object managedBean)

  Return the class to be used for the JMX descriptor field "class". Only applied when the "exposeClassDescriptor" property is "true".

  The default implementation returns the first implemented interface for a JDK proxy, and the target class else.

  Parameters:
    `managedBean` - the bean instance (might be an AOP proxy)
  Returns:
    the class to expose in the descriptor field "class"
  See Also:
    `setExposeClassDescriptor(boolean)`, `AbstractMBeanInfoAssembler.getClassToExpose(Class)`, `AopProxyUtils.proxiedUserInterfaces(Object)`

### includeReadAttribute

    protected abstract boolean includeReadAttribute(java.lang.reflect.Method method,
                                                    java.lang.String beanKey)

  Allows subclasses to vote on the inclusion of a particular attribute accessor.

  Parameters:
    `method` - the accessor `Method`
    `beanKey` - the key associated with the MBean in the beans map of the `MBeanExporter`
  Returns:
    `true` if the accessor should be included in the management interface, otherwise `false```

### includeWriteAttribute

    protected abstract boolean includeWriteAttribute(java.lang.reflect.Method method,
                                                     java.lang.String beanKey)

  Allows subclasses to vote on the inclusion of a particular attribute mutator.

  Parameters:
    `method` - the mutator `Method`.
    `beanKey` - the key associated with the MBean in the beans map of the `MBeanExporter`
  Returns:
    `true` if the mutator should be included in the management interface, otherwise `false```

### includeOperation

    protected abstract boolean includeOperation(java.lang.reflect.Method method,
                                                java.lang.String beanKey)

  Allows subclasses to vote on the inclusion of a particular operation.

  Parameters:
    `method` - the operation method
    `beanKey` - the key associated with the MBean in the beans map of the `MBeanExporter`
  Returns:
    whether the operation should be included in the management interface

### getAttributeDescription

    protected java.lang.String getAttributeDescription(java.beans.PropertyDescriptor propertyDescriptor,
                                                       java.lang.String beanKey)

  Get the description for a particular attribute.

  The default implementation returns a description for the operation that is the name of corresponding `Method`.

  Parameters:
    `propertyDescriptor` - the PropertyDescriptor for the attribute
    `beanKey` - the key associated with the MBean in the beans map of the `MBeanExporter`
  Returns:
    the description for the attribute

### getOperationDescription

    protected java.lang.String getOperationDescription(java.lang.reflect.Method method,
                                                       java.lang.String beanKey)

  Get the description for a particular operation.

  The default implementation returns a description for the operation that is the name of corresponding `Method`.

  Parameters:
    `method` - the operation method
    `beanKey` - the key associated with the MBean in the beans map of the `MBeanExporter`
  Returns:
    the description for the operation

### getOperationParameters

    protected javax.management.MBeanParameterInfo[] getOperationParameters(java.lang.reflect.Method method,
                                                                           java.lang.String beanKey)

  Create parameter info for the given method.

  The default implementation returns an empty arry of `MBeanParameterInfo`.

  Parameters:
    `method` - the `Method` to get the parameter information for
    `beanKey` - the key associated with the MBean in the beans map of the `MBeanExporter`
  Returns:
    the `MBeanParameterInfo` array

### populateMBeanDescriptor

    protected void populateMBeanDescriptor(javax.management.Descriptor descriptor,
                                           java.lang.Object managedBean,
                                           java.lang.String beanKey)

  Allows subclasses to add extra fields to the `Descriptor` for an MBean.

  The default implementation sets the `currencyTimeLimit` field to the specified "defaultCurrencyTimeLimit", if any (by default none).

  Overrides:
    `populateMBeanDescriptor` in class `AbstractMBeanInfoAssembler`
  Parameters:
    `descriptor` - the `Descriptor` for the MBean resource.
    `managedBean` - the bean instance (might be an AOP proxy)
    `beanKey` - the key associated with the MBean in the beans map of the `MBeanExporter`
  See Also:
    `setDefaultCurrencyTimeLimit(Integer)`, `applyDefaultCurrencyTimeLimit(javax.management.Descriptor)`

### populateAttributeDescriptor

    protected void populateAttributeDescriptor(javax.management.Descriptor desc,
                                               java.lang.reflect.Method getter,
                                               java.lang.reflect.Method setter,
                                               java.lang.String beanKey)

  Allows subclasses to add extra fields to the `Descriptor` for a particular attribute.

  The default implementation sets the `currencyTimeLimit` field to the specified "defaultCurrencyTimeLimit", if any (by default none).

  Parameters:
    `desc` - the attribute descriptor
    `getter` - the accessor method for the attribute
    `setter` - the mutator method for the attribute
    `beanKey` - the key associated with the MBean in the beans map of the `MBeanExporter`
  See Also:
    `setDefaultCurrencyTimeLimit(Integer)`, `applyDefaultCurrencyTimeLimit(javax.management.Descriptor)`

### populateOperationDescriptor

    protected void populateOperationDescriptor(javax.management.Descriptor desc,
                                               java.lang.reflect.Method method,
                                               java.lang.String beanKey)

  Allows subclasses to add extra fields to the `Descriptor` for a particular operation.

  The default implementation sets the `currencyTimeLimit` field to the specified "defaultCurrencyTimeLimit", if any (by default none).

  Parameters:
    `desc` - the operation descriptor
    `method` - the method corresponding to the operation
    `beanKey` - the key associated with the MBean in the beans map of the `MBeanExporter`
  See Also:
    `setDefaultCurrencyTimeLimit(Integer)`, `applyDefaultCurrencyTimeLimit(javax.management.Descriptor)`

### applyDefaultCurrencyTimeLimit

    protected final void applyDefaultCurrencyTimeLimit(javax.management.Descriptor desc)

  Set the `currencyTimeLimit` field to the specified "defaultCurrencyTimeLimit", if any (by default none).

  Parameters:
    `desc` - the JMX attribute or operation descriptor
  See Also:
    `setDefaultCurrencyTimeLimit(Integer)`

### applyCurrencyTimeLimit

    protected void applyCurrencyTimeLimit(javax.management.Descriptor desc,
                                          int currencyTimeLimit)

  Apply the given JMX "currencyTimeLimit" value to the given descriptor.

  The default implementation sets a value `>0` as-is (as number of cache seconds), turns a value of `0` into `Integer.MAX_VALUE` ("always cache") and sets the "defaultCurrencyTimeLimit" (if any, indicating "never cache") in case of a value `<0`. This follows the recommendation in the JMX 1.2 specification.

  Parameters:
    `desc` - the JMX attribute or operation descriptor
    `currencyTimeLimit` - the "currencyTimeLimit" value to apply
  See Also:
    `setDefaultCurrencyTimeLimit(Integer)`, `applyDefaultCurrencyTimeLimit(javax.management.Descriptor)`

Overview | Package | Class | Tree | Deprecated | Index | Help
| Spring Framework
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD